package ipsk.webapps.filter;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;

public class EncodingFilter implements Filter {

	public static final String DEFAULT_ENCODING = "UTF-8";

	private String encoding=DEFAULT_ENCODING;
	
	  public void doFilter(ServletRequest request,
	      ServletResponse response, FilterChain filterChain)
	      throws IOException, ServletException {

	    request.setCharacterEncoding(encoding);
	    filterChain.doFilter(request, response);
	  }

	  public void init(FilterConfig filterConfig)
		           throws ServletException {
	    String encodingParam = filterConfig
	              .getInitParameter("encoding");
	    if (encodingParam != null) {
	      encoding = encodingParam;
	    }
	  }

	  public void destroy() {
	    // nothing todo
	  }

}
